<?php
/**
 * @version SOFORT Gateway - $Date: 2012-11-06 09:25:15 +0100 (Di, 06 Nov 2012) $
 * @author SOFORT AG (integration@sofort.com)
 * @link http://www.sofort.com/
 *
 * Copyright (c) 2012 SOFORT AG
 *
 * $Id: callback.php 5607 2012-11-06 08:25:15Z rotsch $
 */

if (!defined('IS_ADMIN_FLAG')) {
	die('Illegal Access');
}

require_once(DIR_WS_MODULES.'payment/sofort/helperFunctions.php');
require_once(DIR_WS_MODULES.'payment/sofort/library/sofortLib.php');
require_once(DIR_WS_MODULES.'payment/sofort/library/sofortLib_classic_notification.inc.php');
require_once(DIR_WS_MODULES.'payment/sofort/library/helper/class.invoice.inc.php');
require_once(DIR_WS_MODULES.'payment/sofort/ressources/scripts/sofortOrderSynchronisation.php');

$language = HelperFunctions::getSofortLanguage($_SESSION['language']);

if (file_exists(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_su.php')) require_once(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_su.php');
if (file_exists(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_sr.php')) require_once(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_sr.php');
if (file_exists(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_sv.php')) require_once(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_sv.php');
if (file_exists(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_sl.php')) require_once(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_sl.php');
if (file_exists(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_ls.php')) require_once(DIR_WS_LANGUAGES.$language.'/modules/payment/sofort_ls.php');

if ($_GET['sofort_action'] == 'ideal'){ // iDeal
	die('Error: iDEAL is not implemented here! Exit.');
} elseif ($_GET['sofort_action'] == 'su'){ // SU-classic
	die('Error: SOFORT Ueberweisung (classic) is not implemented here! Exit.');
} elseif ($_GET['sofort_action'] == 'multipay' || !$_GET['sofort_action']) { // Multipay
	$SofortLib_Notification = new SofortLib_Notification();
	$transactionId = $SofortLib_Notification->getNotification();
	
	if (defined('MODULE_PAYMENT_SOFORT_MULTIPAY_LOG_ENABLED') && MODULE_PAYMENT_SOFORT_MULTIPAY_LOG_ENABLED == "True") {
		$SofortLib_Notification->setLogEnabled();
		$loggingEnabled = true;
	} else {
		$loggingEnabled = false;
	}
	
	if (empty($transactionId)) {
		if ($loggingEnabled){
			$SofortLib_Notification->logError('Transaction-ID empty! Order-status could not be updated. Check shop for incomplete orders! Notification-Object: '.print_r($SofortLib_Notification, true));
		}
		
		exit('Error: Request could not be processed.');
	}
	
	$time = $SofortLib_Notification->getTime();
	$time = date('d.m.Y, G:i:s', strtotime($time));
	$SofortLib_TransactionData = new SofortLib_TransactionData(MODULE_PAYMENT_SOFORT_MULTIPAY_APIKEY);
	
	if (!is_object($SofortLib_TransactionData) || !($SofortLib_TransactionData instanceof SofortLib_TransactionData)) {
		if ($loggingEnabled){
			$SofortLib_Notification->logError("TransactionData-Object corrupt. Transaction-ID: $transactionId. Check order!");
		}
		
		exit('Error: Request could not be processed.');
	}
	
	$SofortLib_TransactionData->setTransaction($transactionId);
	$SofortLib_TransactionData->sendRequest();
	
	if ($SofortLib_TransactionData->isError()) {
		if ($loggingEnabled){
			$SofortLib_Notification->logError("Error in TransactionData: ".print_r($SofortLib_TransactionData->getError(), true)."Transaction-ID: $transactionId. Check order!");
		}
		
		exit('Error: Request could not be processed.');
	}
	
	$paymentMethod = $SofortLib_TransactionData->getPaymentMethod();
	$paymentSecret = $_REQUEST['paymentSecret'];
	
	if (!HelperFunctions::checkPaymentSecret($paymentSecret, $transactionId)) {
		if ($loggingEnabled){
			$SofortLib_Notification->logError("Wrong Payment-Secret given for Transaction-ID: $transactionId! Check order!");
		}
		
		exit('Error: Request could not be processed.');
	}
	
	$notificationStatusReason = $SofortLib_TransactionData->getStatusReason();
	$notificationStatus = $SofortLib_TransactionData->getStatus();
	
	$orderId = HelperFunctions::getOrderId($transactionId);
	
	if (!$orderId) {
		if ($loggingEnabled){
			$SofortLib_Notification->logError("Order-ID not found for Transaction-ID: $transactionId! Check order!");
		}
		
		exit('Error: Request could not be processed.');
	}
	
	if ($orderId != $SofortLib_TransactionData->getUserVariable(0)) {
		if ($loggingEnabled){
			$SofortLib_Notification->logError("TransactionData-Order-ID and Shop-Order-ID differ. Transaction-ID: $transactionId! Check order!");
		}
		
		exit('Error: Request could not be processed.');
	}
}

//Notice: Following code ist not compatible with ideal or sofortueberweisung-classic! They have to be implemented above/anywhere!

$dbEntries = array(
		'amount' => $SofortLib_TransactionData->getAmount(),
		'status' => $notificationStatus,
		'status_reason' => $notificationStatusReason,
);

$PnagInvoice = '';
if ($paymentMethod == 'sr') {
	$PnagInvoice = new PnagInvoice(MODULE_PAYMENT_SOFORT_MULTIPAY_APIKEY, $transactionId);
	if ($PnagInvoice->isError()) {
		$SofortLib_Notification->logError("Errors while creating invoice-object: ".
			print_r($PnagInvoice->getErrors(), true)." Transaction-ID: $transactionId. Check order!");
		exit('Error: Request could not be processed.');
	}
	$dbEntries['status_id'] = $PnagInvoice->getState();
}

$notificationStatusShort = HelperFunctions::getShortStatus($paymentMethod, $notificationStatus, $notificationStatusReason);
$newShopStatus = HelperFunctions::getNewShopStatusId($notificationStatusShort, $orderId, $SofortLib_Notification);
$historyComments = HelperFunctions::getHistoryComments($notificationStatusShort, $orderId, $SofortLib_TransactionData, $transactionId, false, $SofortLib_Notification);

$tableSofortOrdersNotificationIsEmpty = HelperFunctions::hasEntriesInTableSofortNotifications($transactionId);

//save all relevant data in table sofort_notification
//this DB-entry also prevents race-conditions between call of successUrl and notification
//@see hasEntriesInTableSofortNotifications() and statusAndReasonDidNotChange()
//must be set (preferably direct) after call of getHistoryComments() because of a check inside
HelperFunctions::insertSofortOrdersNotification($transactionId, $dbEntries, $SofortLib_Notification);

//special features for SR
if ($paymentMethod == 'sr') {

	//if buyer has changed addresses at sofort-wizard -> set new addresses also in shopsystem
	if ($notificationStatusShort == 'sr_pen_con_inv' && !$tableSofortOrdersNotificationIsEmpty) {
		HelperFunctions::updateShopAdresses($SofortLib_TransactionData->getInvoiceAddress(), $SofortLib_TransactionData->getShippingAddress(), $orderId, $SofortLib_Notification);
	}

	//insert comment into history, if amount has changed
	$isNewTotal = HelperFunctions::checkIfNewTotal($SofortLib_TransactionData->getAmount(), $orderId, true, $SofortLib_Notification);
	if ($isNewTotal && !invoiceWasReanimated($orderId, $notificationStatus, true)) {
		$oldTotal = HelperFunctions::getLastFieldValueFromSofortTable($orderId, 'amount', true);
		$lastOrderStatus = HelperFunctions::getLastOrderStatus($orderId);
		HelperFunctions::insertNewTotalCommentToHistory($orderId, $lastOrderStatus, $oldTotal, $SofortLib_TransactionData->getAmount(), $time, $SofortLib_Notification);
	}

	//sync SOFORT-articles/orderTotals with the shop-articles/orderTotals
	if(!checkIfNewOrder($orderId)){
		$SofortOrderSynchronisation = new sofortOrderSynchronisation();
		$SofortOrderSynchronisation->editArticlesShop($PnagInvoice, $orderId);
	}
	
	//invoice was canceled (after confirmation) and now reanimated again
	if (invoiceWasReanimated($orderId, $notificationStatus, true)) {
		if (!$newShopStatus) {
			$newShopStatus = MODULE_PAYMENT_SOFORT_SR_PEN_NOT_CRE_YET_STATUS_ID; //if $newShopStatus is unknown, set the SR-confirmed-status
		}
		HelperFunctions::insertHistoryEntry($orderId, $newShopStatus, MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_REANIMATED, '', $time);
		HelperFunctions::updateTableOrdersStatus($orderId, $newShopStatus);
		//FIXME reset stock and check cart
	}
}

//insert all data into orders-table and orders_status_history-table
if ($historyComments['buyer']) {
	if (!$newShopStatus) {
		$SofortLib_Notification->logError("Status for buyer-comment (".$historyComments['buyer'].") unknown. Comment will not be inserted. Check order! Order-Id: $orderId, Transaction-ID: $transactionId!");
		exit('Error: Request could not be processed.');
	}
	HelperFunctions::insertHistoryEntry($orderId, $newShopStatus, $historyComments['buyer'], '', $time);
}

if ($historyComments['seller']) {
	HelperFunctions::insertHistoryEntry($orderId, -1, $historyComments['seller'], '', $time);
}

//if $newShopStatus is set, set it into table orders
if ($newShopStatus) {
	HelperFunctions::updateTableOrdersStatus($orderId, $newShopStatus);
}

//all finished
exit('Callback.php processed.');


//////////////////////////////////////////////////////////
//////////////// ONLY FUNCTIONS FOLLOWING ////////////////
//////////////////////////////////////////////////////////
//////// MORE FUNCTIONS AT CLASS HELPERFUNCTIONS /////////
//////////////////////////////////////////////////////////


function checkIfNewOrder($orderId){
	$res = mysql_query("SELECT id FROM ".HelperFunctions::escapeSql(DB_PREFIX)."sofort_orders WHERE orders_id = '".HelperFunctions::escapeSql($orderId)."'");
	$row = mysql_fetch_array($res);
	
	$res = mysql_query("SELECT * FROM ".HelperFunctions::escapeSql(DB_PREFIX)."sofort_orders_notification WHERE sofort_orders_id = '".HelperFunctions::escapeSql($row['id'])."'");
	
	if (mysql_num_rows($res)) {
		return false;
	} else {
		return true;
	}
}

/**
 * (only SR) Check if an already refunded invoice was enabled again
 * @param bool $checkAgainstPenultimateEntry (optional) - if current notification is already inserted, we must check against the penultimate entry in table_orders_notification
 * @return boolean
 */
function invoiceWasReanimated($orderId, $notificationStatus, $checkAgainstPenultimateEntry = false) {
	$lastStatus = HelperFunctions::getLastFieldValueFromSofortTable($orderId, 'status', $checkAgainstPenultimateEntry);
	
	if ($lastStatus == 'refunded' && $notificationStatus != 'refunded') {
		return true;
	} else {
		return false;
	}
}
