<?php
/**
 * @version SOFORT Gateway - $Date: 2012-11-06 18:36:45 +0100 (Di, 06 Nov 2012) $
 * @author SOFORT AG (integration@sofort.com)
 * @link http://www.sofort.com/
 *
 * Copyright (c) 2012 SOFORT AG
 *
 * $Id: sofort_ls.php 5627 2012-11-06 17:36:45Z rotsch $
 */

include_once ((IS_ADMIN_FLAG === true ? DIR_FS_CATALOG_MODULES : DIR_WS_MODULES).'payment/sofort/sofort.php');

class sofort_ls extends sofort {
	
	/**
	 * checked ok
	 */
	function sofort_ls() {
		global $order;
		
		$this->code = 'sofort_ls';
		
		parent::sofort();
		
		$this->_checkExistingSofortConstants('ls');
		
		//zen-Bug: sometimes admin-title is called for public-view
		if ($_GET['main_page'] == FILENAME_CHECKOUT_CONFIRMATION || $_GET['main_page'] == FILENAME_CHECKOUT_PROCESS) {
			$this->title = MODULE_PAYMENT_SOFORT_LS_TEXT_TITLE;
		} else {
			$this->title = MODULE_PAYMENT_SOFORT_LASTSCHRIFT_TEXT_TITLE;
		}
		
		$this->title_extern = MODULE_PAYMENT_SOFORT_LS_TEXT_TITLE;
		$this->paymentMethod = 'LS';
		
		if (defined('MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT') && MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT == 'True') {
			$this->title_extern .= ' ' . MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT_TEXT;
		}
		
		$this->enabled = ((defined('MODULE_PAYMENT_SOFORT_LS_STATUS') && MODULE_PAYMENT_SOFORT_LS_STATUS == 'True') ? true : false);
		
		$this->description = MODULE_PAYMENT_SOFORT_LS_TEXT_DESCRIPTION.'<br />'.MODULE_PAYMENT_SOFORT_MULTIPAY_VERSIONNUMBER.': '.HelperFunctions::getSofortmodulVersion();
		if ($this->_isInstalled() && (!defined('MODULE_PAYMENT_SOFORT_MULTIPAY_MODULE_VERSION') || 
				strcasecmp(trim(MODULE_PAYMENT_SOFORT_MULTIPAY_MODULE_VERSION), trim(HelperFunctions::getSofortmodulVersion())) != 0)) {
			$this->description = '<span style ="color:red; font-weight: bold; font-size: 1.2em">'.MODULE_PAYMENT_SOFORT_MULTIPAY_UPDATE_NOTICE.'</span><br /><br />'.$this->description;
		}
		$this->description .= MODULE_PAYMENT_SOFORT_LS_TEXT_DESCRIPTION_EXTRA;
		
		$this->sort_order = (defined('MODULE_PAYMENT_SOFORT_LS_SORT_ORDER') ? MODULE_PAYMENT_SOFORT_LS_SORT_ORDER : false);
		
		if (is_object($order)) {
			$this->update_status();
		}
		
		if (defined('MODULE_PAYMENT_SOFORT_LS_STATUS')) {
			$this->sofort = new SofortLib_Multipay(MODULE_PAYMENT_SOFORT_MULTIPAY_APIKEY);
			$this->sofort->setVersion(HelperFunctions::getSofortmodulVersion());
			if (defined('MODULE_PAYMENT_SOFORT_MULTIPAY_LOG_ENABLED') && MODULE_PAYMENT_SOFORT_MULTIPAY_LOG_ENABLED == "True") {
				$this->sofort->setLogEnabled();
			}
		}
	}
	
	
	/**
	 * checked ok
	 */
	function selection() {
		global $order;
		
		if (!parent::selection()) {
			$this->sofort->log("Notice: Paymentmethod ".$this->code." will be deactivated for selection.");
			$this->enabled = false;
			return false;
		}
		
		//very long words within title will be overlaped by checkbox - this is a zen-bug! @see: stylesheet.css->inputLabelPayment->width
		$fields = array(
			array('title' => MODULE_PAYMENT_SOFORT_LS_TEXT_HOLDER,
					'field' => zen_draw_input_field('sofort_ls_sender_holder', array_key_exists('sofort_ls_sender_holder', $_SESSION['sofort']) ? strip_tags($_SESSION['sofort']['sofort_ls_sender_holder']) : strip_tags($order->billing['firstname'] . ' ' . $order->billing['lastname']))),
			array('title' => MODULE_PAYMENT_SOFORT_LS_TEXT_ACCOUNT_NUMBER,
					'field' => zen_draw_input_field('sofort_ls_account_number', array_key_exists('sofort_ls_account_number', $_SESSION['sofort']) ? strip_tags($_SESSION['sofort']['sofort_ls_account_number']) : '')),
			array('title' => MODULE_PAYMENT_SOFORT_LS_TEXT_BANK_CODE,
					'field' => zen_draw_input_field('sofort_ls_bank_code', array_key_exists('sofort_ls_bank_code', $_SESSION['sofort']) ? strip_tags($_SESSION['sofort']['sofort_ls_bank_code']) : '')),
			array('title' => MODULE_PAYMENT_SOFORT_LS_CHECKOUT_CONDITIONS,
					'field' => zen_draw_checkbox_field('sofort_conditions_ls', 'sofort_conditions_ls', false))
			);
		
		return array(
			'id'	 => $this->code,
			'module' => $this->title_extern.MODULE_PAYMENT_SOFORT_MULTIPAY_JS_LIBS,
			'fields' => $fields,
		);
	}
	
	
	/**
	 * checked ok
	 */
	function pre_confirmation_check() {
		
		parent::pre_confirmation_check();
		
		$requestData = $_POST;
		
		$_SESSION['sofort']['sofort_ls_sender_holder']     = trim($requestData['sofort_ls_sender_holder']);
		$_SESSION['sofort']['sofort_ls_account_number']    = trim($requestData['sofort_ls_account_number']);
		$_SESSION['sofort']['sofort_ls_bank_code']         = trim($requestData['sofort_ls_bank_code']);
		
		$requestData['sofort_conditions_ls']        = trim($requestData['sofort_conditions_ls']);
		$_SESSION['sofort']['sofort_conditions_ls'] = isset($requestData['sofort_conditions_ls']) ? $requestData['sofort_conditions_ls'] : '';
		
		$errorCodes = array();
		$errorFound = false;
		if ($_SESSION['sofort']['sofort_conditions_ls'] != 'sofort_conditions_ls') {
			$errorFound = true;
			$errorCodes[] = '10002';
		}
		
		if (!$_SESSION['sofort']['sofort_ls_sender_holder'] ||
			!$_SESSION['sofort']['sofort_ls_account_number'] ||
			!$_SESSION['sofort']['sofort_ls_bank_code']) {
			$errorFound = true;
			$errorCodes[] = '10001';
		}
		
		if ($errorFound) {
			$errorString = '&payment_error='.$this->code.'&error_codes='.implode(',', $errorCodes);
			zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, $errorString, 'SSL', true, false));
		}
		
		return false;
	}
	
	
	/**
	 * checked ok
	 */
	function install() {
		global $db;
		
		//install shared keys and lang-files, that are used by all/most multipay-modules
		if (parent::install() === 'failed') {
			return 'failed';
		}
		
		$sofortStatuses = $this->_insertAndReturnSofortStatus();
		$directDebitStatus = 	(isset($sofortStatuses['direct_debit'])		&& !empty($sofortStatuses['direct_debit']))		? $sofortStatuses['direct_debit'] : '';
		$refundedStatus = 		(isset($sofortStatuses['refunded'])			&& !empty($sofortStatuses['refunded']))			? $sofortStatuses['refunded'] : '';
		$returnedDebitStatus = 	(isset($sofortStatuses['returned_debit'])	&& !empty($sofortStatuses['returned_debit']))	? $sofortStatuses['returned_debit'] : '';
		$unchangedStatus = 		(isset($sofortStatuses['unchanged'])		&& !empty($sofortStatuses['unchanged']))		? $sofortStatuses['unchanged'] : '';
		
		$db->Execute("INSERT INTO " . HelperFunctions::escapeSql(TABLE_CONFIGURATION) . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_STATUS_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_STATUS', 'False', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_STATUS_DESC)."', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
		$db->Execute("INSERT INTO " . HelperFunctions::escapeSql(TABLE_CONFIGURATION) . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_SORT_ORDER_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_SORT_ORDER', '0', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_SORT_ORDER_DESC)."', '6', '16', now())");
		$db->Execute("INSERT INTO " . HelperFunctions::escapeSql(TABLE_CONFIGURATION) . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT', 'False', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT_DESC)."', '6', '5', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
		$db->Execute("INSERT INTO " . HelperFunctions::escapeSql(TABLE_CONFIGURATION) . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_COUNTRIES_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_COUNTRIES', '', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_COUNTRIES_DESC)."', '6', '12', now())");
		$db->Execute("INSERT INTO " . HelperFunctions::escapeSql(TABLE_CONFIGURATION) . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_ZONE_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_ZONE', '0', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_ZONE_DESC)."', '6', '13', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
		
		//"Bestaetigt - Bisher kein Geldeingang" - pending-not_credited_yet
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_PEN_NOT_CRE_YET_STATUS_ID_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_PEN_NOT_CRE_YET_STATUS_ID', '".HelperFunctions::escapeSql($directDebitStatus)."',  '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_PEN_NOT_CRE_YET_STATUS_ID_DESC)."', '6', '35', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		
		//"Ruecklastschrift" - loss-rejected
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_LOS_REJ_STATUS_ID_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_LOS_REJ_STATUS_ID', '".HelperFunctions::escapeSql($returnedDebitStatus)."',  '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_LOS_REJ_STATUS_ID_DESC)."', '6', '35', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		
		//"Geldeingang" - received-credited
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_REC_CRE_STATUS_ID_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_REC_CRE_STATUS_ID', '".HelperFunctions::escapeSql($unchangedStatus)."',  '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_REC_CRE_STATUS_ID_DESC)."', '6', '35', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		
		//"Teilrueckbuchung" - refunded-compensation
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_REF_COM_STATUS_ID_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_REF_COM_STATUS_ID', '".HelperFunctions::escapeSql($unchangedStatus)."',  '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_REF_COM_STATUS_ID_DESC)."', '6', '35', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		
		//"Vollstaendige Rueckbuchung" - refunded-refunded
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_REF_REF_STATUS_ID_TITLE)."', 'MODULE_PAYMENT_SOFORT_LS_REF_REF_STATUS_ID', '".HelperFunctions::escapeSql($refundedStatus)."',  '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_LS_REF_REF_STATUS_ID_DESC)."', '6', '35', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
	}
	
	
	/**
	 * checked ok
	 */
	function remove() {
		global $db;
		
		$db->Execute("DELETE FROM " . HelperFunctions::escapeSql(TABLE_CONFIGURATION) . " WHERE configuration_key LIKE 'MODULE_PAYMENT_SOFORT_LS%'");
		$db->Execute("DELETE FROM " . HelperFunctions::escapeSql(TABLE_CONFIGURATION) . " WHERE configuration_key LIKE 'MODULE_PAYMENT_SOFORT_LASTSCHRIFT%'");
		
		//if this is the last removing of a multipay-paymentmethod --> we also remove all shared keys, that are used by all/most multipay-modules
		parent::remove();
	}
	
	
	/**
	 * checked ok
	 */
	function keys() {
		
		parent::keys();
		
		return array(
			'MODULE_PAYMENT_SOFORT_LS_STATUS',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_APIKEY',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_AUTH',
			'MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_REASON_1',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_TEXT_REASON_2',
			'MODULE_PAYMENT_SOFORT_LS_COUNTRIES',
			'MODULE_PAYMENT_SOFORT_LS_ZONE',
			'MODULE_PAYMENT_SOFORT_LS_SORT_ORDER',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_PROF_SETTINGS',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_TEMP_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_ABORTED_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_LS_PEN_NOT_CRE_YET_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_LS_LOS_REJ_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_LS_REC_CRE_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_LS_REF_COM_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_LS_REF_REF_STATUS_ID',
			//'MODULE_PAYMENT_SOFORT_MULTIPAY_LOG_ENABLED',
		);
	}
}
